.include "8515def.inc"

.equ Time = 8000 
.equ Dwn = 0            ; Flag0= eine Taste war gedrckt
.equ Rpt = 1            ; Flag1= Taste wiederholt gedrckt

.def Last = r14         ; letzter Tastentatus
.def Stat = r15         ; Speicher SREG
.def temp = r16         ; Arbeitsregister
.def Flg = r18          ; Flags des Programmes 
.def Mode = r19         ; Mode-Register

.org 0x000

rjmp Reset
reti
reti
reti
reti
reti
reti

Timer0:                    ; Timer berlauf-Interrupt alle 20ms

in Stat, SREG              ; SREG sichern

ldi temp, -Time
out TCNT0, temp            ; Timer nachladen

in temp, PinD              ; Tasten einlesen
sbrs Flg, Dwn              ; wenn beim letzen Int. keine Taste gedrckt war
rjmp T1                    ; Sprung ; Flag Dwn = 0

cpse Last,temp             ; immer noch selbe Taste wie beim letzten Int 
rjmp T1                    ; Sprung, wenn nicht selbe Taste 
sbrc Flg, Rpt              ; Taste dauerbettigt
rjmp IntEnd                ; Srung bei Dauerbettigung Flag Rpt = 1
mov Mode, temp             ; Modus setzen
sbr Flg, Rpt               ; Flag Rpt setzen
rjmp Ausgabe               ; Tasten Ausgeben
T1:
cpi temp, 0xFF             ; Taste gedrckt
brne T2                    ; Sprung, wenn Taste gedrckt
ldi temp, 0xff             ;
out PortB, temp            ; LED`s aus       
cbr Flg,1<<Dwn             ; Flag Dwn lschen; keine Taste war gedrckt
cbr Flg,1<<Rpt             ; Flag Rpt lschen; keine Dauerbettigung
rjmp IntEnd                ; Sprung
T2:
mov Last, temp             ; Taste abspeichern
cbr Flg,1<<Rpt             ; Flag Rpt lschen; keine Dauerbettigung
sbr Flg,1<<Dwn             ; Flag Dwn setzen; Taste war gedrckt
rjmp IntEnd                ; Sprung

IntEnd:

out SREG, Stat             ; SREG restaurieren
reti

Reset:

ldi temp, high(ramend)
out sph, temp
ldi temp, low (ramend)
out spl, temp              ;Stack initialisiert

ldi temp, 0xff
out ddrb, temp             ; PortB = Ausgang
out portb,temp             ; LED aus

ldi temp, 0x00
out ddrd, temp             ; PortD = Eingang

ldi temp, 0x01
out tccr0, temp            ; Timertakt = 1:1
ldi temp, 0x02
out timsk, temp            ; Timer OVF freigeben

sei                        ; Interrupts freigeben
Wait:
ldi temp,0x20
out MCUCR, temp
sleep
nop
rjmp Wait

Ausgabe:

sbrs mode, 0
rjmp mode0
sbrs mode, 1
rjmp mode1
sbrs mode, 2
rjmp mode2
sbrs mode, 3
rjmp mode3
sbrs mode, 4
rjmp mode4
sbrs mode, 5
rjmp mode5
sbrs mode, 6
rjmp mode6
sbrs mode, 7
rjmp mode7

mode0:

ldi temp, 0b11111110
out PortB, temp
rjmp IntEnd

mode1:

ldi temp, 0b11111101
out PortB, temp
rjmp IntEnd

mode2:

ldi temp, 0b11111011
out PortB, temp
rjmp IntEnd

mode3:

ldi temp, 0b11110111
out PortB, temp
rjmp IntEnd

mode4:

ldi temp, 0b11101111
out PortB, temp
rjmp IntEnd

mode5:

ldi temp, 0b11011111
out PortB, temp
rjmp IntEnd

mode6:

ldi temp, 0b10111111
out PortB, temp
rjmp IntEnd

mode7:

ldi temp, 0b01111111
out PortB, temp
rjmp IntEnd
